require './lib/smsone/sms'


# TODO
# Test code for the following scenarios
# - 3 possible errors (out of numerous ones... get MVP out)
# - complete request balance test code

class Messaging; include Smsone::Sms; end

describe Messaging do
  describe 'sending out messages' do
    before do
      ResponseObjClass = Struct.new(:username, :password) do
        def code
          '202'
        end

        def body
          'status=0&msgid=sms0512064727974228'
        end

        def response
          nil
        end
      end

      resp_obj = ResponseObjClass.new 'username', 'password'
      resp = {:response => resp_obj}

      expect_any_instance_of(Messaging).to receive(:request_balance).and_return(resp)
    end

    let(:messaging) { Messaging.new }

    it 'responds to #send_sms' do
      response = messaging.send_sms 'username',
                                          'password',
                                          '256772501811',
                                          'ensi',
                                          'hi there'
      expect(response.code).to eq "202"
      expect(response.body).to eq 'status=0&msgid=sms0512064727974228'
    end
  end

  describe 'checking balance of credits' do

    it 'responds to #request_balance' do
      response = messaging.request_balance 'username', 'password'
      expect(response[:response].code).to eq '202'
      expect(response[:response].body).to eq 'status=0& total_credit_bal=95.000'
    end

  end

end
